package crystal.ast;

public class NumberExpr extends PrimitiveExpr {
	private static final long serialVersionUID = 3688790254311977522L;

	public static NumberExpr zero = new NumberExpr(0);
	public static NumberExpr one  = new NumberExpr(1);
	
	Number n;
	
	public boolean isZero() {
		return n.intValue() == 0;
	}
	
	public NumberExpr(int n) {
		this.n = new Integer(n);
	}

	public NumberExpr(Number n) {
		this.n = n;
	}
	
	public Number getNumber() {
		return n;
	}
	
	public int numExprKids() {
		return 0;
	}
    
	public Expression getExprKid(int i) {
		return null;
	}

	public void setExprKid(int i, Expression newE) {
		assert (false);
	}
	
	public Number constValue() {
		if (n instanceof Byte || 
				n instanceof Integer || 
				n instanceof Double)
			return n;
		else
			return null;
	}

	public <S,T> S accept(ExprVisitor<S,T> v, T t) {
		return v.visit(this, t);		
	}
}
