package crystal.projects.leakcontradictor;

import crystal.analysis.pointer.*;
import java.util.*;

/** The index portion of the abstraction element. */
public class I {
	Region          region;
	HashSet<Region> plusRegions;
	HashSet<Region> minusRegions;

	boolean           missedByReturn;     /* Set true if entry is creates as being overwritten
						 by a return statement */

	public I(Region r) {
		region = r;
	}

	String toStringDot() {
		//### fixup?
		return region.toString();
	}
	
	static I newI(Region r, HashSet<Region> plus, HashSet<Region> minus, boolean missedByReturn) {
		I i = new I(r);
		i.missedByReturn = missedByReturn;
		i.plusRegions  = plus;
		i.minusRegions = minus;
		return i.hash();
	}

	private I hash() {
		Wrapper si = new Wrapper(this);
		I i = table.get(si);
		if (i != null) 
			return i;
		else {
			table.put(si, this);
			return this;
		}
	}
		
	private static Map<Wrapper,I> table = new HashMap<Wrapper,I>();

	static void flushIndexTable() {
		table.clear();
	}
	
	class Wrapper {
		I i;
		Wrapper(I i) { this.i = i; }
		
		public boolean equals(Object other) {
			if (!(other instanceof Wrapper)) 
				return false;
			
			Wrapper o = (Wrapper) other;
			
			return i.plusRegions.equals (o.i.plusRegions) &&
			       i.minusRegions.equals(o.i.minusRegions) &&
			       i.region == o.i.region &&
			       i.missedByReturn == o.i.missedByReturn;
		}
		
		public int hashCode() {
			return i.plusRegions.hashCode() + i.minusRegions.hashCode() + i.region.hashCode() + (missedByReturn ? 1 : 0);
		}
	}

}
